class Z:
    def __init__(self, n, v):
        self.n = n
        self.v = v
        return

    ## Zbrajanje
    def __add__(self, a):
        return Z(self.n, (self.v + a.v) % self.n)

    ## Množenje
    def __mul__(self, a):
        return Z(self.n, self.v * a.v % self.n)

    ## Aditivni inverz
    def __neg__(self):
        return Z(self.n, self.n - self.v)

    ## Oduzimanje
    def __sub__(self, a):
        return Z(self.n, self.v + (-a).v)

    ## Potenciranje uključujući i multiplikativni inverz
    def __pow__(self, n):
        if (n < 0):
            i = 1
            while i <= self.n and i * self.v % self.n != 1:
                i += 1
            if i <= self.n:
                return Z(self.n, (i ** -n) % self.n)
            else:
                return -1
        else:
            return Z(self.n, self.v ** n % self.n)

    ## Dijeljenje
    def __truediv__(self, a):
        return self * (a ** -1)
    
    def __repr__(self):
        return str(self.v)

    ## Predefiniranje funkcije int()
    def __int__(self):
        return self.v
