class Matrica:  
    def __init__(self, n, m = 0):
        self.n = n                                           
        if m == 0:
            self.m = n
        else:    
            self.m = m
        self.mat = dict()
        return

    def __setitem__(self, ključ, vrijednost):
        self.mat[ključ] = vrijednost
        return

    def __getitem__(self, ključ):
        return self.mat.get(ključ, 0)
   
    def __repr__(self):
        s = ''
        for i in range(self.n):
            for j in range(self.m):
                s = s + '{0:3d}'.format(self[i, j])      
            s = s + '\n'
        return s

    def __add__(self, druga):
        if self.n != druga.n or self.m != druga.m:
            print('Zbrajati se mogu samo matrice jednakih dimenzija')
            return
        else:
            zbroj = Matrica(self.n, self.m)
            for i in range(self.n):
                for j in range(self.m):
                    zbroj[i, j] = self[i, j] + druga[i, j]
        return zbroj
        
    def __mul__(self, druga):
        if self.m != druga.n:
            print('''Matrica se može množiti drugom matricom 
                  ako je njezin broj redaka jednak broju stupaca druge 
                  matrice''')
            return
        else:
            umnožak = Matrica(self.n, druga.m)
            for i in range(self.n):
                for j in range(druga.m):
                    for k in range(self.m):
                        umnožak[i, j] += self[i, k] * druga[k, j]
            return umnožak

    def transp(self):
        transponirana = Matrica(self.m, self.n)
        for i in range(self.n):
            for j in range(self.m):
                transponirana[i, j] = self[j, i]       
        return transponirana

    def gornje_trokutasta(self):
        for i in range(self.n):
            for j in range(i):
                if self[i, j] != 0:
                    return False
        return True

