def sort_zamjenom(lista):
    '''Funkcija obavlja sortiranje zamjenom elemenata'''
    for i in range(len(lista) - 1):
        for j in range(i + 1, len(lista)):
            if lista[i] > lista[j]:
                lista[i], lista[j] = lista[j], lista[i]
    return lista

def sort_izborom(lista):
    '''Funkcija obavlja sortiranje izborom elemenata najmanje vrijednosti'''
    for i in range(len(lista) - 1):
        k = i
        for j in range(i + 1, len(lista)):
            if lista[k] > lista[j]:
                k = j
        if k != i:
            lista[i], lista[k] = lista[k], lista[i]
    return lista


def sort_bubble(lista):
    '''Funkcija obavlja sortiranje bubble sort algoritmom'''
    k = 1
    zamjene = True
    while zamjene:
        zamjene = False
        for i in range(len(lista) - k):
            if lista[i] > lista[i + 1]:
                lista[i], lista[i + 1] = lista[i + 1], lista[i]
                zamjene = True
        k += 1
    return lista

def sort_umetanjem(lista):
    '''Funkcija obavlja sortiranje umetanjem elemenata'''
    for i in range(1, len(lista)):
        j = i
        while j > 0 and lista[j] < lista[j - 1]:
            lista[j - 1], lista[j] = lista[j], lista[j - 1]
            j -= 1
    return lista


def sort_merge(lista):    
    if len(lista) == 1:
        return lista                                           
    m = len(lista) // 2 								#2 
    lijevo = lista[:m]                                          
    desno = lista[m:]                                           
    sort_merge(lijevo)                                          
    sort_merge(desno)                                          
    i, j = 0, 0
    for k in range(len(lijevo) + len(desno)):
        if i < len(lijevo) and j < len(desno):
            if lijevo[i] < desno[j]:
                lista[k] = lijevo[i]
                i += 1
            else:
                lista[k] = desno[j]
                j += 1
        elif i < len(lijevo):
            lista[k] = lijevo[i]
            i += 1
        else:
            lista[k] = desno[j]
            j += 1    
    return lista


def sort_quick(lista, ind_p, ind_k):
    '''Funkcija sortira listu lista čiji su granični indeksi
          ind_p - indeks početnog elementa liste
          ind_k - indeks zadnjeg elementa liste'''
    sred = lista[(ind_p + ind_k) // 2]                          
    i = ind_p                                                   
    j = ind_k                                                   
    while i <= j:                                               
        while lista[i] < sred:
            i += 1                                                
        while lista[j] > sred:                                  
            j -= 1            
        if i <= j:            
            lista[i], lista[j] = lista[j], lista[i]             
            i += 1
            j -= 1
    if ind_p < j:                                                
        sort_quick(lista, ind_p, j)                             
    if ind_k > i:                                                
        sort_quick(lista, i, ind_k)                         
    return lista

def sort_u_pretince(lista):
    '''Prolazom kroz listu stvara se rječnik.
    Ključevi su vrijednosti pronađene u listi a vrijednosti 
    su broj pojavljivanja te vrijednosti u listi.
    U drugoj se fazi kreiraju redom liste za pojedine ključeve
    i tako izgrađuje sortirana lista.'''
    rječnik = {}
    for t in lista:                                             
        rječnik[t] = rječnik.get(t, 0) + 1                      
    sortirano = []
    for k in range(min(rječnik), max(rječnik) + 1):           
        if k in rječnik:
            sortirano.extend([k] * rječnik[k])                  
    return sortirano

